// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include "counter.hh"

Counter::Counter()
{
  s = 8;
  count = 0;
  type = loop;
}

Counter::Counter(int a)
{
  s = a;
  count = 0;
  type = loop;
}

int
Counter::operator++()
{
  ++count;
  
  if (count >= s) {
    if (type == once)
      count = s - 1;
    else 
      count = 0;
  }
  
  return count;
}

int
Counter::operator--()
{
 --count;

 if (count < 0) {
   count = s - 1;
 }
 return count;
}

int
Counter::get_value()
{
  return count;
}

int
Counter::set_count(int i)
{
  return count = i;
}

int
Counter::set_size(int new_size)
{
  s = new_size;
  if (count > s || count < 0) {
    count = 0;
  }
}

int 
Counter::size()
{
  return s;
}

void 
Counter::set_type(CounterType new_type)
{
  type = new_type;
}

/* EOF */
