// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <cassert>

#include "mouse.hh"

int  Mouse::num_buttons;
bool Mouse::mouse_ready = false;

int 
Mouse::init()
{
  if (CL_Input::pointers[0] && CL_Input::pointers[0]->get_cursor(0)) {
    cout << "Mouse Support available, " 
	 << (num_buttons = CL_Input::pointers[0]->get_num_buttons())
	 << " buttons found." << endl;
    mouse_ready = true;
    return 1;
  } else {
    mouse_ready = false;
    return 0;
  }

}

int
Mouse::get_x()
{
  assert(mouse_ready);
  return (int)CL_Input::pointers[0]->get_cursor(0)->get_x();
}

int
Mouse::get_y()
{
  assert(mouse_ready);
  return (int)CL_Input::pointers[0]->get_cursor(0)->get_y();
}

bool
Mouse::is_pressed(int button)
{
  if (button > num_buttons || button < 0) {
    cout << "Mouse Button Number wrong!" << endl;
    return false;
  }

  if (mouse_ready) {
    //    cout << button << CL_Input::pointers[0]->get_button(button)->is_pressed() << endl;
    return CL_Input::pointers[0]->get_button(button)->is_pressed();
  } else {
    cout << "Mouse not ready" << endl;
    return false;
  }
}

/* EOF */
