// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PLAYFIELD_HH
#define PLAYFIELD_HH

#include <ClanLib/clanlib.h>

#include "range.hh"
#include "button_panel.hh"
#include "gui_obj.hh"
#include "world.hh"

class Playfield : public GuiObj
{
private:  
  Range x_offset, y_offset;
  int current_pingu;
  CL_Surface* buffer;
  static CL_Surface* cap;
  CL_InputSourceProvider* datafile;
  vector<Pingu* >* pingu;
  ButtonPanel* buttons;

public:
  World world;
  Playfield();
  Playfield(PLF*);
  ~Playfield();

  void draw();
  void let_move();
  void set_buttons(ButtonPanel* b);
  static void load_data(CL_ResourceManager*);
};

#endif

/* EOF */
