// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <ClanLib/clanlib.h>

#include "counter.hh"
#include "window.hh"
#include "globals.hh"

Window::Window()
{
}

// Add an object to the object list
void
Window::add_obj(GuiObj* new_obj)
{
  obj.push_back(new_obj);
}

// Redraw the complete screen/window
void
Window::draw()
{
  for(int i=0; i < obj.size(); ++i) 
    obj[i]->draw();
}

// Let the window move its content
void
Window::let_move()
{
  for(int i=0; i < obj.size(); ++i) 
    obj[i]->let_move();
}

void
Window::main_loop()
{
  // BUG: Ok, this funtion works, but it is't very nice it should be
  // complitly rewritten. Also the window class for the game should be 
  // 

  bool quit = false;
  int  time = CL_System::get_time();
  int  frames = 0;
  bool skip_frame = false;
  double fps = 0;
  double exact_fps = 0;
  int time_d = CL_System::get_time();
  Counter loop_counter(15);
  
  while (quit != true) {
    CL_System::keep_alive();

    if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_ESCAPE) == true)
      quit = true;
      
    if (CL_System::get_time() > time_d + game_speed) {
      let_move();
      time_d = CL_System::get_time();
    }
    
    if (print_fps && int(loop_counter) > 10) 
      cout << CL_System::get_time() - time_d << " bogus-fps" << endl;
    
    draw();
    CL_Display::flip_display();
    ++loop_counter;
  }

    /*
    // Keeping the game sped constant
    for(;;) {
      if (CL_System::get_time() > time_d + game_speed) { 

	time_d = CL_System::get_time();
	break;
      } else {
	for(int i=0; i < obj.size(); ++i) 
	  obj[i]->draw();
	CL_Display::flip_display();
      }
    }

    // Update the screen
    if (!skip_frame) {
      for(int i=0; i < obj.size(); ++i) 
	obj[i]->draw();
      
      CL_Display::flip_display();
    } 

    fps = (1000.0) / (CL_System::get_time() - time);
    
    time = CL_System::get_time();
    if (fps < global_frame_rate)
      skip_frame = true;
    else
      skip_frame = false;
    
    ++frames;
    exact_fps += fps;

    if (frames == 25) {
      frames = 0;
      if (print_fps)
	cout << exact_fps << " - " << exact_fps / 25.0 << " fps" << endl;
      exact_fps=  0;
    }
  }*/
}

/* EOF */
